// Code generated by 'go generate'

package optional

import (
	"encoding/json"
	"errors"
)

// Error is an optional error.
type Error struct {
	value *error
}

// NewError creates an optional.Error from a error.
func NewError(v error) Error {
	return Error{&v}
}

// NewErrorFromPtr creates an optional.Error from a error pointer.
func NewErrorFromPtr(v *error) Error {
	if v == nil {
		return Error{}
	}
	return NewError(*v)
}

// Set sets the error value.
func (e *Error) Set(v error) {
	e.value = &v
}

// ToPtr returns a *error of the value or nil if not present.
func (e Error) ToPtr() *error {
	if !e.Present() {
		return nil
	}
	v := *e.value
	return &v
}

// Get returns the error value or an error if not present.
func (e Error) Get() (error, error) {
	if !e.Present() {
		var zero error
		return zero, errors.New("value not present")
	}
	return *e.value, nil
}

// MustGet returns the error value or panics if not present.
func (e Error) MustGet() error {
	if !e.Present() {
		panic("value not present")
	}
	return *e.value
}

// Present returns whether or not the value is present.
func (e Error) Present() bool {
	return e.value != nil
}

// OrElse returns the error value or a default value if the value is not present.
func (e Error) OrElse(v error) error {
	if e.Present() {
		return *e.value
	}
	return v
}

// If calls the function f with the value if the value is present.
func (e Error) If(fn func(error)) {
	if e.Present() {
		fn(*e.value)
	}
}

func (e Error) MarshalJSON() ([]byte, error) {
	if e.Present() {
		return json.Marshal(e.value)
	}
	return json.Marshal(nil)
}

func (e *Error) UnmarshalJSON(data []byte) error {

	if string(data) == "null" {
		e.value = nil
		return nil
	}

	var value error

	if err := json.Unmarshal(data, &value); err != nil {
		return err
	}

	e.value = &value
	return nil
}
